      SUBROUTINE SF62R(NN,XX,ENX,EXPENX)
      INTEGER NN,N
      REAL XX,ENX,EXPENX,SYS051,SYS056,SYS059,ABS,EXP,ALOG,
     1FLOAT,X,RN,RM,ONE,TWO,TM,D,PSI,SUM,ZERO,ULPS,HALF,
     1ASUM,XLOG,FMM2,FMM1,GMM2,GMM1,PREV,RNM1,AM,BM,FM,F,
     1EXPNX,EULER,ONPTEV,PTERM,SYS053,R,GM,TEMP,SYS039
      EQUIVALENCE(EULER,SYS039)
C     SYS056 = SYS055
      DATA  SYS056 /1.175495E-38/
      DATA  SYS059/3.4E38/,SYS039/
     10.5772157/,SYS051/1.192093E-07/,SYS053/3.4E38/,
     1HALF,ONE,ONPTEV,TWO,ULPS,ZERO/.5E0,1.E0,1.5E0,2.E0,
     11.E0,0.0E0/
      X=XX
      N=NN
      IF(X.LT.ZERO) X=ABS(X)
      IF(N.LT.0) N=IABS(N)
      RN=FLOAT(N)
      IF(X.EQ.ZERO) GO TO 1
      EXPNX=EXP(-X)
      XLOG=ALOG(X)
      IF(N.NE.0) GO TO 4
      IF(X.LE.SYS056) GO TO 2
      EXPENX=ONE/X
      ENX=EXPNX*EXPENX
      GO TO 20
    1 IF(N.LE.1) GO TO 2
      ENX=ONE/(RN-ONE)
      GO TO 3
    2 ENX=SYS059
    3 EXPENX=ENX
      GO TO 20
    4 IF(X.LE.ULPS) GO TO 5
      IF(X.LE.(SYS059-RN)) GO TO 13
      EXPENX=ZERO
      ENX=EXPENX
      GO TO 20
    5 RM=0
      PTERM=-ONE
      SUM=0
      PSI=-EULER
      D=-(RN-ONE)
    6 IF(D.GE.HALF) GO TO 8
      IF(-D.GE.HALF) GO TO 7
      SUM=PTERM*(XLOG-PSI)+SUM
      GO TO 12
    7 PSI=PSI+(ONE/(RM+ONE))
    8 TM=PTERM/D
      SUM=TM+SUM
      IF(SUM.LT.ZERO) GO TO 9
      ASUM=SUM
      GO TO 10
    9 ASUM=-SUM
   10 IF(ASUM) 11,12,11
   11 IF(TM.LT.ZERO) TM=-TM
      IF(TM/ASUM.GT.SYS051) GO TO 12
      ENX=SUM
      EXPENX=ENX/EXPNX
      GO TO 20
   12 RM=RM+ONE
      D=D+ONE
      PTERM=-(X*PTERM)/RM
      GO TO 6
   13 RM=ONE
      FMM2=ONE
      GMM2=0
      FMM1=0
      GMM1=ONE
      PREV=FMM1/GMM1
      AM=ONE
      BM=X+RN
      RNM1=RN-ONE
   14 FM=BM*FMM1+AM*FMM2
      GM=BM*GMM1+AM*GMM2
      F=FM/GM
      TEMP=ONE-(PREV/F)
      IF(TEMP.GT.ZERO) GO TO 15
      EXPENX=PREV
      GO TO 16
   15 IF(TEMP.GT.SYS051) GO TO 17
      EXPENX=F
   16 ENX=EXPNX*EXPENX
      GO TO 20
   17 IF(GM.LT.SYS053/BM) GO TO 18
      FMM1=FMM1/BM
      GMM1=GMM1/BM
      FM=FM/BM
      GM=GM/BM
      GO TO 19
   18 IF(GM.LT.SYS053/ABS(AM)) GO TO 19
      R=ABS(AM)
      FMM1=FMM1/R
      GMM1=GMM1/R
      FM=FM/R
      GM=GM/R
   19 CONTINUE
      AM=-RM*(RNM1+RM)
      RM=RM+ONE
      BM=BM+TWO
      FMM2=FMM1
      GMM2=GMM1
      FMM1=FM
      GMM1=GM
      PREV=F
      GO TO 14
   20 RETURN
      END
